---
- name: Get last version of Alertmanager
  ansible.builtin.uri:
    url: '{{ alertmanager_github }}'
    body_format: json
  register: page

- name: Set url and path
  ansible.builtin.set_fact:
    alertmanager_url: https://github.com/prometheus/alertmanager/releases/download/{{ page.json.tag_name }}/alertmanager-{{
      page.json.tag_name[1:] }}.linux-{{ alertmanager_arch }}.tar.gz
    alertmanager_dist_path: '{{ alertmanager_tmp_dir }}/alertmanager -{{ page.json.tag_name[1:] }}.linux-{{
      alertmanager_arch }}'

- name: Download alertmanager
  ansible.builtin.get_url:
    url: '{{ alertmanager_url }}'
    dest: '{{ alertmanager_tmp_dir }}/alertmanager.tar.gz'
    mode: 0644
  become: true

- name: Extract alertmanager
  ansible.builtin.unarchive:
    src: '{{ alertmanager_tmp_dir }}/alertmanager.tar.gz'
    dest: '{{ alertmanager_tmp_dir }}'
    remote_src: true

- name: Copy alertmanager binary
  ansible.builtin.copy:
    src: '{{ alertmanager_dist_path }}/alertmanager'
    dest: '{{ alertmanager_bin }}'
    mode: 0755
    remote_src: true
  become: true

- name: Copy alertmanager default config
  ansible.builtin.copy:
    src: '{{ alertmanager_dist_path }}/alertmanager.yml'
    dest: '{{ alertmanager_conf_dir }}/alertmanager.yml'
    mode: 0644
    remote_src: true
  become: true

- name: Create service file
  ansible.builtin.template:
    src: alertmanager.service.j2
    dest: /etc/systemd/system/alertmanager.service
    mode: 0644
  become: true
  notify: alertmanager_start_enable

- name: Allow connections on port 9093
  ansible.builtin.iptables:
    chain: INPUT
    protocol: tcp
    destination_port: '{{ alertmanager_bind_port }}'
    jump: ACCEPT
  become: true
